<?php
namespace Services;

use Zeedhi\Framework\DataSource\FilterCriteria;
use \Setforms2\Shared\ORM\DateTime;
use \Zeedhi\Framework\DB\StoredProcedure\StoredProcedure;
use \Zeedhi\Framework\DB\StoredProcedure\Param;
use \Teknisa\Model\Geral\Entities\Lista;

class Mym00109AnalisePesquisaSatisfacaoService {

	protected $util;
    protected $dataSourceManager;
    protected $environment;
    protected $entityManager;
    protected $novoCodigo;
	
	public function __construct($util, $dataSourceManager, $environment, $entityManager, $novoCodigo) {
        $this->util = $util;
		$this->dataSourceManager = $dataSourceManager;
        $this->environment = $environment;
        $this->entityManager = $entityManager;
		$this->novoCodigo = $novoCodigo;
	}

    public function geraLista($nrorg, $lista, $separador) {

        $lista = explode($separador, $lista);
        
        try {
            $nrlista = $this->novoCodigo->getCodeByTableName('LISTA', $nrorg);
            foreach ($lista as $item) {
                $sql = "INSERT INTO LISTA (CDLISTA, NRLISTA, NRORG) VALUES (:CDLISTA, :NRLISTA, :NRORG)";
                $params = array(
                    "CDLISTA" => $item,
                    "NRLISTA" => $nrlista,
                    "NRORG" => $nrorg
                );
                $stmt = $this->entityManager->getConnection()->prepare($sql);
                $stmt->execute($params);
            }
            return $nrlista;
        } catch (\Excepition $e){
            $response->setError(new Error($e->getMessage(), $e->getCode()));
         }
    }

    public function deletaLista($nrorg, $nrlista) {
        try {
            $sql = "DELETE FROM LISTA WHERE NRLISTA = :NRLISTA AND NRORG = :NRORG)";
                $params = array(
                    "NRLISTA" => $nrlista,
                    "NRORG" => $nrorg
                );
                $stmt = $this->entityManager->getConnection()->prepare($sql);
                $stmt->execute($params);
        } catch (\Excepition $e){
            $response->setError(new Error($e->getMessage(), $e->getCode()));
        }  
        return true;
    }
}