/* @C:\web_509\SQL\end_conv\oracle\4203_GOPTRGO_LOG_FASEORCOPERAC.sql
   Trigger criada para gerar log das transaes na tabela GRUPGERENTEOP */

CREATE OR REPLACE TRIGGER LOG_FASEORCOPERAC
AFTER DELETE OR UPDATE OR INSERT
ON FASEORCOPERAC FOR EACH ROW
DECLARE
  V_USUARIO      VARCHAR2(40);
  V_TIPO         VARCHAR2(1);
  V_ITPESQ       VARCHAR2(40);
  V_DESC         VARCHAR2(300);
  V_DTOPER       DATE;
  V_DSREMOTEADDR VARCHAR2(15);
  V_DSREMOTEHOST VARCHAR2(15);
  V_DSSERVERRDM  VARCHAR2(20);
  V_DSSERVMETHOD VARCHAR2(30);
  V_DSREMOTEOPER VARCHAR2(12);
BEGIN
   V_TIPO := '0';
   V_DESC := '';

   IF DELETING THEN

      IF :OLD.CDFASEORCOPERAC IS NOT NULL THEN
         V_DESC := V_DESC || ' CdFase=' || :OLD.CDFASEORCOPERAC;
      END IF;

      IF :OLD.NMFASEORCOPERAC IS NOT NULL THEN
         V_DESC := V_DESC || ' NmFase=' || :OLD.CDFASEORCOPERAC;
      END IF;

      V_TIPO         := '3';
      V_ITPESQ       := :OLD.CDFASEORCOPERAC;
   ELSE
      IF UPDATING THEN
         IF (:OLD.NMFASEORCOPERAC  <> :NEW.NMFASEORCOPERAC) THEN
               V_DESC := V_DESC || ' NmFase=' ||:NEW.NMFASEORCOPERAC;
         END IF;

         IF (:OLD.NRDIASALERTA  <> :NEW.NRDIASALERTA) THEN
               V_DESC := V_DESC || ' NumDias=' ||:NEW.NRDIASALERTA;
         END IF;

         IF (:OLD.IDFASECALCORCA  <> :NEW.IDFASECALCORCA) THEN
               V_DESC := V_DESC || ' IdFaseCalc=' ||:NEW.IDFASECALCORCA;
         END IF;

         IF (:OLD.IDFASEAPROVORCA  <> :NEW.IDFASEAPROVORCA) THEN
               V_DESC := V_DESC || ' IdFaseAprov=' ||:NEW.IDFASEAPROVORCA;
         END IF;

         V_TIPO         := '2';
         V_ITPESQ       := :OLD.CDFASEORCOPERAC;
      ELSE
         V_TIPO         := '1';
         V_ITPESQ       := :NEW.CDFASEORCOPERAC;

         IF :NEW.CDFASEORCOPERAC IS NOT NULL THEN
            V_DESC := V_DESC || ' CdFase=' || :NEW.CDFASEORCOPERAC;
         END IF;

         IF :NEW.NMFASEORCOPERAC IS NOT NULL THEN
            V_DESC := V_DESC || ' CdFase=' || :NEW.NMFASEORCOPERAC;
         END IF;
      END IF;
   END IF;

   IF V_TIPO <> '0' THEN
      NMUSUARIO(V_USUARIO);
      WEBTUNNING(V_DSREMOTEADDR,
                 V_DSREMOTEHOST,
                 V_DSSERVERRDM,
                 V_DSSERVMETHOD,
                 V_DSREMOTEOPER);
      IF NOT V_DESC IS NULL THEN
         IF NOT V_USUARIO IS NULL THEN
            V_DTOPER := SYSDATE;

            INSERT INTO LOGOPERA
               (NMTABELA,   DTOPERACAO, NMRESPOPER,
                IDTIPOOPER, CDPESQITEM, DSOPERACAO)
            VALUES
               ('FASEORCOPERAC',  V_DTOPER, V_USUARIO,
                V_TIPO,      V_ITPESQ, V_DESC);
         END IF;
      END IF;
   END IF;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('LOG_FASEORCOPERAC','5.09.000'); END;
/
