/******************************************************************************/
/*                                                                            */
/* Trigger: OPERADOR_SAAS                                                     */
/* Tabela : OPERADOR                                                          */
/*                                                                            */
/* Criao:                                                                   */
/* 29/03/2017 - Newton N. Santos                                              */
/*                                                                            */
/******************************************************************************/

CREATE OR REPLACE TRIGGER OPERADOR_SAAS
AFTER INSERT OR UPDATE OR DELETE ON OPERADOR
FOR EACH ROW

DECLARE
  V_IDOPERSAAS VARCHAR2(01);
  C_OPER_SAAS SYS_REFCURSOR;
  V_SELECT_OPERSAAS LONG;
  
  V_EXIST_OPER_SAAS BOOLEAN;
  V_CDOPERADOR OPERADOR.CDOPERADOR%TYPE;
  V_NRORG OPERADOR.NRORG%TYPE;
  
BEGIN
   IF (INSERTING OR UPDATING) AND (:NEW.NRORG <> 20) THEN BEGIN
		BEGIN
			V_SELECT_OPERSAAS := 'SELECT NVL(IDOPERSAAS, ''S'') FROM OPERADOR WHERE CDOPERADOR = '''||:NEW.CDOPERADOR||''' AND NRORG = '||:NEW.NRORG;
			OPEN C_OPER_SAAS FOR V_SELECT_OPERSAAS;
         LOOP
				FETCH C_OPER_SAAS INTO V_IDOPERSAAS;
            EXIT WHEN C_OPER_SAAS%NOTFOUND;         
         END LOOP;
         CLOSE C_OPER_SAAS;
		EXCEPTION
			WHEN OTHERS THEN BEGIN
				V_IDOPERSAAS := 'S';
			END;	
		END;
		
		V_EXIST_OPER_SAAS := TRUE;
		BEGIN
			 SELECT CDOPERADOR, NRORG
				INTO V_CDOPERADOR, V_NRORG
				FROM USR_ORG_SAAS.OPERADOR
			  WHERE CDOPERADOR = :OLD.CDOPERADOR
				 AND NRORG = :OLD.NRORG;
		EXCEPTION
			WHEN NO_DATA_FOUND THEN BEGIN
				V_EXIST_OPER_SAAS := FALSE;
			END;	
		END;
	
		IF (V_IDOPERSAAS = 'S') AND (NVL(:NEW.IDOPERATIVO, 'A') = 'A') AND (INSERTING OR (NOT V_EXIST_OPER_SAAS)) THEN
			INSERT INTO USR_ORG_SAAS.OPERADOR (CDOPERADOR, CDPAIS, SGESTADO, CDMUNICIPIO, NMOPERADOR, NMACESSO, NMCOMPLOPER, DTNASCIMENTO, 
			                           DSENDEOPER, NMBAIROPER, NRCEPOPER, NRTELEOPER, CDSENHOPER, DTULTATUOPER, CDCLIENTE, NROPERREDE, 
												CDEMPRESA, CDFUNC, NRRAMALOPER, IDLIGEXTOPER, IDSENHVARDIA, DSEMAILOPER, IDOPERMASTER, 
												IDOPERACESSO, CDSENEMAILOP, IDOPERATIVO, CDSETOR, IDFUNINIOPER, HRINIAGEOPER, HRFIMAGEOPER, 
												CDCARGO, DTULTATUSENH, IDTPOPERADOR, IDSTATUSENHA, DTULTACESOPER, NRCELULAROPER, IDATUOPERADOR, 
												CDBANCOPER, CDAGENOPER, CDCCOROPER, NRORG, DTINCLUSAO, DTULTATU, NRORGINCLUSAO, CDOPERINCLUSAO, 
												NRORGULTATU, CDOPERULTATU, CDSENHAOPERWEB, CDOPERESPLIBSEN, NRPARCNEGOCIO, CDPROCHABLANOPE, 
												CDPROCHABAPROPE, CDPROCHABFECOPE, NRORGSELECIONADA, CDFILIALSELECIONADA, NRPERFILSELECIONADO, 
												IDCADPRAPROVORE, IDCADPRPROCEORE, IDATIVO, NRORGFILIAL, NRORGTRAB, NRESTRUTTRAB, IDIDIOMA, 
												USR_NRORDEMSETOR, SGOPERADOR, CDSENHAOPERMD5, DSHASHALTERASENHA, DSEMAILOPER_BKP, NROPERREDE_BKP, 
												DSCRIPTORECSENHA)
				  VALUES (:NEW.CDOPERADOR, :NEW.CDPAIS, :NEW.SGESTADO, :NEW.CDMUNICIPIO, :NEW.NMOPERADOR, :NEW.NMACESSO, :NEW.NMCOMPLOPER, :NEW.DTNASCIMENTO, 
				          :NEW.DSENDEOPER, :NEW.NMBAIROPER, :NEW.NRCEPOPER, :NEW.NRTELEOPER, :NEW.CDSENHOPER, :NEW.DTULTATUOPER, :NEW.CDCLIENTE, :NEW.NROPERREDE, 
							 :NEW.CDEMPRESA, :NEW.CDFUNC, :NEW.NRRAMALOPER, :NEW.IDLIGEXTOPER, :NEW.IDSENHVARDIA, :NEW.DSEMAILOPER, :NEW.IDOPERMASTER, 
							 :NEW.IDOPERACESSO, :NEW.CDSENEMAILOP, :NEW.IDOPERATIVO, :NEW.CDSETOR, :NEW.IDFUNINIOPER, :NEW.HRINIAGEOPER, :NEW.HRFIMAGEOPER, 
							 :NEW.CDCARGO, :NEW.DTULTATUSENH, :NEW.IDTPOPERADOR, :NEW.IDSTATUSENHA, :NEW.DTULTACESOPER, :NEW.NRCELULAROPER, :NEW.IDATUOPERADOR, 
							 :NEW.CDBANCOPER, :NEW.CDAGENOPER, :NEW.CDCCOROPER, :NEW.NRORG, :NEW.DTINCLUSAO, :NEW.DTULTATU, :NEW.NRORGINCLUSAO, :NEW.CDOPERINCLUSAO, 
							 :NEW.NRORGULTATU, :NEW.CDOPERULTATU, :NEW.CDSENHAOPERWEB, :NEW.CDOPERESPLIBSEN, :NEW.NRPARCNEGOCIO, :NEW.CDPROCHABLANOPE, 
							 :NEW.CDPROCHABAPROPE, :NEW.CDPROCHABFECOPE, :NEW.NRORGSELECIONADA, :NEW.CDFILIALSELECIONADA, :NEW.NRPERFILSELECIONADO, 
							 :NEW.IDCADPRAPROVORE, :NEW.IDCADPRPROCEORE, :NEW.IDATIVO, :NEW.NRORGFILIAL, :NEW.NRORGTRAB, :NEW.NRESTRUTTRAB, :NEW.IDIDIOMA, 
							 :NEW.USR_NRORDEMSETOR, :NEW.SGOPERADOR, :NEW.CDSENHAOPERMD5, :NEW.DSHASHALTERASENHA, :NEW.DSEMAILOPER_BKP, :NEW.NROPERREDE_BKP, 
							 :NEW.DSCRIPTORECSENHA);							
		END IF;
		
		IF (V_IDOPERSAAS = 'S') AND (NVL(:NEW.IDOPERATIVO, 'A') = 'A') AND (UPDATING AND V_EXIST_OPER_SAAS)  THEN
			UPDATE USR_ORG_SAAS.OPERADOR 
				SET CDOPERADOR = :NEW.CDOPERADOR, 
					 CDPAIS = :NEW.CDPAIS, 
					 SGESTADO = :NEW.SGESTADO, 
					 CDMUNICIPIO = :NEW.CDMUNICIPIO, 
					 NMOPERADOR = :NEW.NMOPERADOR, 
					 NMACESSO = :NEW.NMACESSO, 
					 NMCOMPLOPER = :NEW.NMCOMPLOPER, 
					 DTNASCIMENTO = :NEW.DTNASCIMENTO, 
					 DSENDEOPER = :NEW.DSENDEOPER, 
					 NMBAIROPER = :NEW.NMBAIROPER, 
					 NRCEPOPER = :NEW.NRCEPOPER, 
					 NRTELEOPER = :NEW.NRTELEOPER, 
					 CDSENHOPER = :NEW.CDSENHOPER, 
					 DTULTATUOPER = :NEW.DTULTATUOPER, 
					 CDCLIENTE = :NEW.CDCLIENTE, 
					 NROPERREDE = :NEW.NROPERREDE, 
					 CDEMPRESA = :NEW.CDEMPRESA, 
					 CDFUNC = :NEW.CDFUNC, 
					 NRRAMALOPER = :NEW.NRRAMALOPER, 
					 IDLIGEXTOPER = :NEW.IDLIGEXTOPER, 
					 IDSENHVARDIA = :NEW.IDSENHVARDIA, 
					 DSEMAILOPER = :NEW.DSEMAILOPER, 
					 IDOPERMASTER = :NEW.IDOPERMASTER, 
					 IDOPERACESSO = :NEW.IDOPERACESSO, 
					 CDSENEMAILOP = :NEW.CDSENEMAILOP, 
					 IDOPERATIVO = :NEW.IDOPERATIVO, 
					 CDSETOR = :NEW.CDSETOR, 
					 IDFUNINIOPER = :NEW.IDFUNINIOPER, 
					 HRINIAGEOPER = :NEW.HRINIAGEOPER, 
					 HRFIMAGEOPER = :NEW.HRFIMAGEOPER, 
					 CDCARGO = :NEW.CDCARGO, 
					 DTULTATUSENH = :NEW.DTULTATUSENH, 
					 IDTPOPERADOR = :NEW.IDTPOPERADOR, 
					 IDSTATUSENHA = :NEW.IDSTATUSENHA, 
					 DTULTACESOPER = :NEW.DTULTACESOPER, 
					 NRCELULAROPER = :NEW.NRCELULAROPER, 
					 IDATUOPERADOR = :NEW.IDATUOPERADOR, 
					 CDBANCOPER = :NEW.CDBANCOPER, 
					 CDAGENOPER = :NEW.CDAGENOPER, 
					 CDCCOROPER = :NEW.CDCCOROPER, 
					 NRORG = :NEW.NRORG, 
					 DTINCLUSAO = :NEW.DTINCLUSAO, 
					 DTULTATU = :NEW.DTULTATU, 
					 NRORGINCLUSAO = :NEW.NRORGINCLUSAO, 
					 CDOPERINCLUSAO = :NEW.CDOPERINCLUSAO, 
					 NRORGULTATU = :NEW.NRORGULTATU, 
					 CDOPERULTATU = :NEW.CDOPERULTATU, 
					 CDSENHAOPERWEB = :NEW.CDSENHAOPERWEB, 
					 CDOPERESPLIBSEN = :NEW.CDOPERESPLIBSEN, 
					 NRPARCNEGOCIO = :NEW.NRPARCNEGOCIO, 
					 CDPROCHABLANOPE = :NEW.CDPROCHABLANOPE, 
					 CDPROCHABAPROPE = :NEW.CDPROCHABAPROPE, 
					 CDPROCHABFECOPE = :NEW.CDPROCHABFECOPE, 
					 NRORGSELECIONADA = :NEW.NRORGSELECIONADA, 
					 CDFILIALSELECIONADA = :NEW.CDFILIALSELECIONADA,  
					 NRPERFILSELECIONADO = :NEW.NRPERFILSELECIONADO,  
					 IDCADPRAPROVORE = :NEW.IDCADPRAPROVORE, 
					 IDCADPRPROCEORE = :NEW.IDCADPRPROCEORE, 
					 IDATIVO = :NEW.IDATIVO, 
					 NRORGFILIAL = :NEW.NRORGFILIAL, 
					 NRORGTRAB = :NEW.NRORGTRAB, 
					 NRESTRUTTRAB = :NEW.NRESTRUTTRAB, 
					 IDIDIOMA = :NEW.IDIDIOMA, 
					 USR_NRORDEMSETOR = :NEW.USR_NRORDEMSETOR, 
					 SGOPERADOR = :NEW.SGOPERADOR, 
					 CDSENHAOPERMD5 = :NEW.CDSENHAOPERMD5, 
					 DSHASHALTERASENHA = :NEW.DSHASHALTERASENHA, 
					 DSEMAILOPER_BKP = :NEW.DSEMAILOPER_BKP, 
					 NROPERREDE_BKP = :NEW.NROPERREDE_BKP, 
					 DSCRIPTORECSENHA = :NEW.DSCRIPTORECSENHA
			 WHERE CDOPERADOR = :OLD.CDOPERADOR
				AND NRORG = :OLD.NRORG;
		END IF;

		IF (NVL(:NEW.IDOPERATIVO, 'A') <> 'A') AND UPDATING AND V_EXIST_OPER_SAAS  THEN
			DELETE 
			  FROM USR_ORG_SAAS.OPERADOR O
			 WHERE O.CDOPERADOR = :NEW.CDOPERADOR
				AND O.NRORG = :NEW.NRORG;
		END IF;
	END IF;
	
	IF DELETING THEN
		DELETE 
		  FROM USR_ORG_SAAS.OPERADOR O
		 WHERE O.CDOPERADOR = :OLD.CDOPERADOR
		   AND O.NRORG = :OLD.NRORG;
	END IF;
END;
/

